'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var config = require('./repositories/config');
var events = require('./repositories/events');
var broadcasters = require('./repositories/broadcasters');
var eventDispatcher = require('./managers/dispatch')(config, events);
var broadcastManager = require('./managers/broadcast')(config, events, broadcasters);

var Burns = function () {
    function Burns() {
        _classCallCheck(this, Burns);
    }

    _createClass(Burns, [{
        key: 'configure',
        value: function configure() {
            var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
                defaultHandler = _ref.defaultHandler,
                broadcaster = _ref.broadcaster,
                pusher = _ref.pusher;

            config.set({ defaultHandler: defaultHandler, broadcaster: broadcaster, pusher: pusher });
            return this;
        }
    }, {
        key: 'registerEvents',
        value: function registerEvents(newEvents) {
            events.add(newEvents);
            return this;
        }
    }, {
        key: 'dispatch',
        value: function dispatch(eventName) {
            var eventData = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

            var _ref2 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {},
                _ref2$exclude = _ref2.exclude,
                exclude = _ref2$exclude === undefined ? null : _ref2$exclude;

            eventDispatcher.dispatch(eventName, eventData);
            broadcastManager.broadcast(eventName, eventData, { exclude: exclude });
            return this;
        }
    }]);

    return Burns;
}();

module.exports = new Burns();