'use strict';

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

module.exports = {

    events: {},

    handlers: function handlers(event) {
        var eventConfig = this.events[event];
        if (eventConfig && Array.isArray(eventConfig.handlers)) {
            return eventConfig.handlers;
        }
        return [];
    },
    broadcastConfig: function broadcastConfig(event) {
        var defaultConfig = { broadcastOn: null, broadcastWhen: null };
        var eventConfig = this.events[event];
        if (eventConfig) {
            return Object.assign({}, defaultConfig, eventConfig);
        }
        return defaultConfig;
    },
    add: function add(events) {
        var _this = this;

        Object.entries(events).forEach(function (_ref) {
            var _ref2 = _slicedToArray(_ref, 2),
                eventName = _ref2[0],
                eventConfig = _ref2[1];

            if (Array.isArray(eventConfig)) {
                // we're dealing with a list of handlers
                _this.addEventHandlers.apply(_this, [eventName].concat(_toConsumableArray(eventConfig)));
            } else if (typeof eventConfig === 'function') {
                //a single event handler
                _this.addEventHandlers(eventName, eventConfig);
            } else {
                // configuration options for the event
                _this.updateEventConfig(eventName, eventConfig);
            }
        });
    },
    addEventHandlers: function addEventHandlers(eventName) {
        for (var _len = arguments.length, handlers = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
            handlers[_key - 1] = arguments[_key];
        }

        if (this.events[eventName] && this.events[eventName].handlers) {
            handlers = [].concat(_toConsumableArray(this.events[eventName].handlers), _toConsumableArray(handlers));
        }
        this.updateEventConfig(eventName, { handlers: handlers });
    },
    updateEventConfig: function updateEventConfig(eventName, config) {
        this.events[eventName] = config;
    }
};